1#!/bin/sh
2#-
3# Copyright (c) 2013-2016 Allan Jude
4# Copyright (c) 2013-2018 Devin Teske
5# All rights reserved.
6#
7# Redistribution and use in source and binary forms, with or without
8# modification, are permitted provided that the following conditions
9# are met:
10# 1. Redistributions of source code must retain the above copyright
11#    notice, this list of conditions and the following disclaimer.
12# 2. Redistributions in binary form must reproduce the above copyright
13#    notice, this list of conditions and the following disclaimer in the
14#    documentation and/or other materials provided with the distribution.
15#
16# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
17# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
20# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26# SUCH DAMAGE.
27#
28# $FreeBSD$
29#
30############################################################ INCLUDES
31
32BSDCFG_SHARE="/usr/share/bsdconfig"
33. $BSDCFG_SHARE/common.subr || exit 1
34f_dprintf "%s: loading includes..." "$0"
35f_include $BSDCFG_SHARE/device.subr
36f_include $BSDCFG_SHARE/dialog.subr
37f_include $BSDCFG_SHARE/password/password.subr
38f_include $BSDCFG_SHARE/variable.subr
39
40############################################################ CONFIGURATION
41
42#
43# Default name of the boot-pool
44#
45: ${ZFSBOOT_POOL_NAME:=zroot}
46
47#
48# Default options to use when creating zroot pool
49#
50: ${ZFSBOOT_POOL_CREATE_OPTIONS:=-O compress=lz4 -O atime=off}
51
52#
53# Default name for the boot environment parent dataset
54#
55: ${ZFSBOOT_BEROOT_NAME:=ROOT}
56
57#
58# Default name for the primary boot environment
59#
60: ${ZFSBOOT_BOOTFS_NAME:=default}
61
62#
63# Default Virtual Device (vdev) type to create
64#
65: ${ZFSBOOT_VDEV_TYPE:=stripe}
66
67#
68# Should we use sysctl(8) vfs.zfs.min_auto_ashift=12 to force 4K sectors?
69#
70: ${ZFSBOOT_FORCE_4K_SECTORS:=1}
71
72#
73# Should we use geli(8) to encrypt the drives?
74# NB: Automatically enables ZFSBOOT_BOOT_POOL
75#
76: ${ZFSBOOT_GELI_ENCRYPTION=}
77
78#
79# Default path to the geli(8) keyfile used in drive encryption
80#
81: ${ZFSBOOT_GELI_KEY_FILE:=/boot/encryption.key}
82
83#
84# Create a separate boot pool?
85# NB: Automatically set when using geli(8) or MBR
86#
87: ${ZFSBOOT_BOOT_POOL=}
88
89#
90# Options to use when creating separate boot pool (if any)
91#
92: ${ZFSBOOT_BOOT_POOL_CREATE_OPTIONS:=}
93
94#
95# Default name for boot pool when enabled (e.g., geli(8) or MBR)
96#
97: ${ZFSBOOT_BOOT_POOL_NAME:=bootpool}
98
99#
100# Default size for boot pool when enabled (e.g., geli(8) or MBR)
101#
102: ${ZFSBOOT_BOOT_POOL_SIZE:=2g}
103
104#
105# Default disks to use (always empty unless being scripted)
106#
107: ${ZFSBOOT_DISKS:=}
108
109#
110# Default partitioning scheme to use on disks
111#
112: ${ZFSBOOT_PARTITION_SCHEME:=}
113
114#
115# Default boot type to use on disks
116#
117: ${ZFSBOOT_BOOT_TYPE:=}
118
119#
120# How much swap to put on each block device in the boot zpool
121# NOTE: Value passed to gpart(8); which supports SI unit suffixes.
122#
123: ${ZFSBOOT_SWAP_SIZE:=2g}
124
125#
126# Should we use geli(8) to encrypt the swap?
127#
128: ${ZFSBOOT_SWAP_ENCRYPTION=}
129
130#
131# Should we use gmirror(8) to mirror the swap?
132#
133: ${ZFSBOOT_SWAP_MIRROR=}
134
135#
136# Default ZFS datasets for root zpool
137#
138# NOTE: Requires /tmp, /var/tmp, /$ZFSBOOT_BOOTFS_NAME/$ZFSBOOT_BOOTFS_NAME
139# NOTE: Anything after pound/hash character [#] is ignored as a comment.
140#
141f_isset ZFSBOOT_DATASETS || ZFSBOOT_DATASETS="
142	# DATASET	OPTIONS (comma or space separated; or both)
143
144	# Boot Environment [BE] root and default boot dataset
145	/$ZFSBOOT_BEROOT_NAME				mountpoint=none
146	/$ZFSBOOT_BEROOT_NAME/$ZFSBOOT_BOOTFS_NAME	mountpoint=/
147
148	# Compress /tmp, allow exec but not setuid
149	/tmp		mountpoint=/tmp,exec=on,setuid=off
150
151	# Don't mount /usr so that 'base' files go to the BEROOT
152	/usr		mountpoint=/usr,canmount=off
153
154	# Home directories separated so they are common to all BEs
155	/usr/home	# NB: /home is a symlink to /usr/home
156
157	# Ports tree
158	/usr/ports	setuid=off
159
160	# Source tree (compressed)
161	/usr/src
162
163	# Create /var and friends
164	/var		mountpoint=/var,canmount=off
165	/var/audit	exec=off,setuid=off
166	/var/crash	exec=off,setuid=off
167	/var/log	exec=off,setuid=off
168	/var/mail	atime=on
169	/var/tmp	setuid=off
170" # END-QUOTE
171
172#
173# If interactive and the user has not explicitly chosen a vdev type or disks,
174# make the user confirm scripted/default choices when proceeding to install.
175#
176: ${ZFSBOOT_CONFIRM_LAYOUT:=1}
177
178############################################################ GLOBALS
179
180#
181# Format of a line in printf(1) syntax to add to fstab(5)
182#
183FSTAB_FMT="%s\t\t%s\t%s\t%s\t\t%s\t%s\n"
184
185#
186# Command strings for various tasks
187#
188COPY='cp "%s" "%s"'
189CHMOD_MODE='chmod %s "%s"'
190DD_WITH_OPTIONS='dd if="%s" of="%s" %s'
191ECHO_APPEND='echo "%s" >> "%s"'
192ECHO_OVERWRITE='echo "%s" > "%s"'
193GELI_ATTACH='geli attach -j - -k "%s" "%s"'
194GELI_ATTACH_NOKEY='geli attach -j - "%s"'
195GELI_DETACH_F='geli detach -f "%s"'
196GELI_PASSWORD_INIT='geli init -b -B "%s" -e %s -J - -K "%s" -l 256 -s 4096 "%s"'
197GELI_PASSWORD_GELIBOOT_INIT='geli init -bg -e %s -J - -l 256 -s 4096 "%s"'
198GPART_ADD_ALIGN='gpart add %s -t %s "%s"'
199GPART_ADD_ALIGN_INDEX='gpart add %s -i %s -t %s "%s"'
200GPART_ADD_ALIGN_INDEX_WITH_SIZE='gpart add %s -i %s -t %s -s %s "%s"'
201GPART_ADD_ALIGN_LABEL='gpart add %s -l %s -t %s "%s"'
202GPART_ADD_ALIGN_LABEL_WITH_SIZE='gpart add %s -l %s -t %s -s %s "%s"'
203GPART_BOOTCODE='gpart bootcode -b "%s" "%s"'
204GPART_BOOTCODE_PART='gpart bootcode -b "%s" -p "%s" -i %s "%s"'
205GPART_BOOTCODE_PARTONLY='gpart bootcode -p "%s" -i %s "%s"'
206GPART_CREATE='gpart create -s %s "%s"'
207GPART_DESTROY_F='gpart destroy -F "%s"'
208GPART_SET_ACTIVE='gpart set -a active -i %s "%s"'
209GPART_SET_LENOVOFIX='gpart set -a lenovofix "%s"'
210GPART_SET_PMBR_ACTIVE='gpart set -a active "%s"'
211GRAID_DELETE='graid delete "%s"'
212KLDLOAD='kldload %s'
213LN_SF='ln -sf "%s" "%s"'
214MKDIR_P='mkdir -p "%s"'
215MOUNT_TYPE='mount -t %s "%s" "%s"'
216NEWFS_ESP='newfs_msdos "%s"'
217PRINTF_CONF="printf '%s=\"%%s\"\\\n' %s >> \"%s\""
218PRINTF_FSTAB='printf "$FSTAB_FMT" "%s" "%s" "%s" "%s" "%s" "%s" >> "%s"'
219SHELL_TRUNCATE=':> "%s"'
220SWAP_GMIRROR_LABEL='gmirror label swap %s'
221SYSCTL_ZFS_MIN_ASHIFT_12='sysctl vfs.zfs.min_auto_ashift=12'
222UMOUNT='umount "%s"'
223ZFS_CREATE_WITH_OPTIONS='zfs create %s "%s"'
224ZFS_MOUNT='zfs mount "%s"'
225ZFS_SET='zfs set "%s" "%s"'
226ZFS_UNMOUNT='zfs unmount "%s"'
227ZPOOL_CREATE_WITH_OPTIONS='zpool create %s "%s" %s %s'
228ZPOOL_DESTROY='zpool destroy "%s"'
229ZPOOL_EXPORT='zpool export "%s"'
230ZPOOL_EXPORT_F='zpool export -f "%s"'
231ZPOOL_IMPORT_WITH_OPTIONS='zpool import %s "%s"'
232ZPOOL_LABELCLEAR_F='zpool labelclear -f "%s"'
233ZPOOL_SET='zpool set %s "%s"'
234
235#
236# Strings that should be moved to an i18n file and loaded with f_include_lang()
237#
238hline_alnum_arrows_punc_tab_enter="Use alnum, arrows, punctuation, TAB or ENTER"
239hline_arrows_space_tab_enter="Use arrows, SPACE, TAB or ENTER"
240hline_arrows_tab_enter="Press arrows, TAB or ENTER"
241msg_an_unknown_error_occurred="An unknown error occurred"
242msg_back="Back"
243msg_cancel="Cancel"
244msg_change_selection="Change Selection"
245msg_configure_options="Configure Options:"
246msg_detailed_disk_info="gpart(8) show %s:\n%s\n\ncamcontrol(8) inquiry %s:\n%s\n\n\ncamcontrol(8) identify %s:\n%s\n"
247msg_disk_info="Disk Info"
248msg_disk_info_help="Get detailed information on disk device(s)"
249msg_disk_plural="disks"
250msg_disk_singular="disk"
251msg_encrypt_disks="Encrypt Disks?"
252msg_encrypt_disks_help="Use geli(8) to encrypt all data partitions"
253msg_error="Error"
254msg_force_4k_sectors="Force 4K Sectors?"
255msg_force_4k_sectors_help="Align partitions to 4K sector boundries and set vfs.zfs.min_auto_ashift=12"
256msg_freebsd_installer="FreeBSD Installer"
257msg_geli_password="Enter a strong passphrase, used to protect your encryption keys. You will be required to enter this passphrase each time the system is booted"
258msg_geli_setup="Initializing encryption on selected disks,\n this will take several seconds per disk"
259msg_install="Install"
260msg_install_desc="Proceed with Installation"
261msg_install_help="Create ZFS boot pool with displayed options"
262msg_invalid_boot_pool_size="Invalid boot pool size \`%s'"
263msg_invalid_disk_argument="Invalid disk argument \`%s'"
264msg_invalid_index_argument="Invalid index argument \`%s'"
265msg_invalid_swap_size="Invalid swap size \`%s'"
266msg_invalid_virtual_device_type="Invalid Virtual Device type \`%s'"
267msg_last_chance_are_you_sure="Last Chance! Are you sure you want to destroy\nthe current contents of the following disks:\n\n   %s"
268msg_last_chance_are_you_sure_color='\\ZrLast Chance!\\ZR Are you \\Z1sure\\Zn you want to \\Zr\\Z1destroy\\Zn\nthe current contents of the following disks:\n\n   %s'
269msg_mirror_desc="Mirror - n-Way Mirroring"
270msg_mirror_help="[2+ Disks] Mirroring provides the best performance, but the least storage"
271msg_missing_disk_arguments="missing disk arguments"
272msg_missing_one_or_more_scripted_disks="Missing one or more scripted disks!"
273msg_no="NO"
274msg_no_disks_present_to_configure="No disk(s) present to configure"
275msg_no_disks_selected="No disks selected."
276msg_not_enough_disks_selected="Not enough disks selected. (%u < %u minimum)"
277msg_null_disk_argument="NULL disk argument"
278msg_null_index_argument="NULL index argument"
279msg_null_poolname="NULL poolname"
280msg_odd_disk_selected="An even number of disks must be selected to create a RAID 1+0. (%u selected)"
281msg_ok="OK"
282msg_partition_scheme="Partition Scheme"
283msg_partition_scheme_help="Select partitioning scheme. GPT is recommended."
284msg_please_enter_a_name_for_your_zpool="Please enter a name for your zpool:"
285msg_please_enter_amount_of_swap_space="Please enter amount of swap space (SI-Unit suffixes\nrecommended; e.g., \`2g' for 2 Gigabytes):"
286msg_please_select_one_or_more_disks="Please select one or more disks to create a zpool:"
287msg_pool_name="Pool Name"
288msg_pool_name_cannot_be_empty="Pool name cannot be empty."
289msg_pool_name_help="Customize the name of the zpool to be created (Required)"
290msg_pool_type_disks="Pool Type/Disks:"
291msg_pool_type_disks_help="Choose type of ZFS Virtual Device and disks to use (Required)"
292msg_processing_selection="Processing selection..."
293msg_raid10_desc="RAID 1+0 - n x 2-Way Mirrors"
294msg_raid10_help="[4+ Disks] Striped Mirrors provides the best performance, but the least storage"
295msg_raidz1_desc="RAID-Z1 - Single Redundant RAID"
296msg_raidz1_help="[3+ Disks] Withstand failure of 1 disk. Recommended for: 3, 5 or 9 disks"
297msg_raidz2_desc="RAID-Z2 - Double Redundant RAID"
298msg_raidz2_help="[4+ Disks] Withstand failure of 2 disks. Recommended for: 4, 6 or 10 disks"
299msg_raidz3_desc="RAID-Z3 - Triple Redundant RAID"
300msg_raidz3_help="[5+ Disks] Withstand failure of 3 disks. Recommended for: 5, 7 or 11 disks"
301msg_rescan_devices="Rescan Devices"
302msg_rescan_devices_help="Scan for device changes"
303msg_select="Select"
304msg_select_a_disk_device="Select a disk device"
305msg_select_virtual_device_type="Select Virtual Device type:"
306msg_stripe_desc="Stripe - No Redundancy"
307msg_stripe_help="[1+ Disks] Striping provides maximum storage but no redundancy"
308msg_swap_encrypt="Encrypt Swap?"
309msg_swap_encrypt_help="Encrypt swap partitions with temporary keys, discarded on reboot"
310msg_swap_invalid="The selected swap size (%s) is invalid. Enter a number optionally followed by units. Example: 2G"
311msg_swap_mirror="Mirror Swap?"
312msg_swap_mirror_help="Mirror swap partitions for redundancy, breaks crash dumps"
313msg_swap_size="Swap Size"
314msg_swap_size_help="Customize how much swap space is allocated to each selected disk"
315msg_swap_toosmall="The selected swap size (%s) is to small. Please enter a value greater than 100MB or enter 0 for no swap"
316msg_these_disks_are_too_small="These disks are smaller than the amount of requested\nswap (%s) and/or geli(8) (%s) partitions, which would\ntake 100%% or more of each of the following selected disks:\n\n  %s\n\nRecommend changing partition size(s) and/or selecting a\ndifferent set of disks."
317msg_unable_to_get_disk_capacity="Unable to get disk capacity of \`%s'"
318msg_unsupported_partition_scheme="%s is an unsupported partition scheme"
319msg_user_cancelled="User Cancelled."
320msg_yes="YES"
321msg_zfs_configuration="ZFS Configuration"
322
323############################################################ FUNCTIONS
324
325# dialog_menu_main
326#
327# Display the dialog(1)-based application main menu.
328#
329dialog_menu_main()
330{
331	local title="$DIALOG_TITLE"
332	local btitle="$DIALOG_BACKTITLE"
333	local prompt="$msg_configure_options"
334	local force4k="$msg_no"
335	local usegeli="$msg_no"
336	local swapgeli="$msg_no"
337	local swapmirror="$msg_no"
338	[ "$ZFSBOOT_FORCE_4K_SECTORS" ] && force4k="$msg_yes"
339	[ "$ZFSBOOT_GELI_ENCRYPTION" ] && usegeli="$msg_yes"
340	[ "$ZFSBOOT_SWAP_ENCRYPTION" ] && swapgeli="$msg_yes"
341	[ "$ZFSBOOT_SWAP_MIRROR" ] && swapmirror="$msg_yes"
342	local disks n disks_grammar
343	f_count n $ZFSBOOT_DISKS
344	{ [ $n -eq 1 ] && disks_grammar=$msg_disk_singular; } ||
345		disks_grammar=$msg_disk_plural # grammar
346	local menu_list="
347		'>>> $msg_install'      '$msg_install_desc'
348		                        '$msg_install_help'
349		'T $msg_pool_type_disks'
350		               '$ZFSBOOT_VDEV_TYPE: $n $disks_grammar'
351		               '$msg_pool_type_disks_help'
352		'- $msg_rescan_devices' '*'
353		                        '$msg_rescan_devices_help'
354		'- $msg_disk_info'      '*'
355		                        '$msg_disk_info_help'
356		'N $msg_pool_name'      '$ZFSBOOT_POOL_NAME'
357		                        '$msg_pool_name_help'
358		'4 $msg_force_4k_sectors'
359		                        '$force4k'
360		                        '$msg_force_4k_sectors_help'
361		'E $msg_encrypt_disks'  '$usegeli'
362		                        '$msg_encrypt_disks_help'
363		'P $msg_partition_scheme'
364		               '$ZFSBOOT_PARTITION_SCHEME ($ZFSBOOT_BOOT_TYPE)'
365		               '$msg_partition_scheme_help'
366		'S $msg_swap_size'      '$ZFSBOOT_SWAP_SIZE'
367		                        '$msg_swap_size_help'
368		'M $msg_swap_mirror'    '$swapmirror'
369		                        '$msg_swap_mirror_help'
370		'W $msg_swap_encrypt'   '$swapgeli'
371		                        '$msg_swap_encrypt_help'
372	" # END-QUOTE
373	local defaultitem= # Calculated below
374	local hline="$hline_alnum_arrows_punc_tab_enter"
375
376	local height width rows
377	eval f_dialog_menu_with_help_size height width rows \
378		\"\$title\" \"\$btitle\" \"\$prompt\" \"\$hline\" $menu_list
379
380	# Obtain default-item from previously stored selection
381	f_dialog_default_fetch defaultitem
382
383	local menu_choice
384	menu_choice=$( eval $DIALOG \
385		--title \"\$title\"              \
386		--backtitle \"\$btitle\"         \
387		--hline \"\$hline\"              \
388		--item-help                      \
389		--ok-label \"\$msg_select\"      \
390		--cancel-label \"\$msg_cancel\"  \
391		--default-item \"\$defaultitem\" \
392		--menu \"\$prompt\"              \
393		$height $width $rows             \
394		$menu_list                       \
395		2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
396	)
397	local retval=$?
398	f_dialog_data_sanitize menu_choice
399	f_dialog_menutag_store "$menu_choice"
400
401	# Only update default-item on success
402	[ $retval -eq $DIALOG_OK ] && f_dialog_default_store "$menu_choice"
403
404	return $retval
405}
406
407# dialog_last_chance $disks ...
408#
409# Display a list of the disks that the user is about to destroy. The default
410# action is to return error status unless the user explicitly (non-default)
411# selects "Yes" from the noyes dialog.
412#
413dialog_last_chance()
414{
415	local title="$DIALOG_TITLE"
416	local btitle="$DIALOG_BACKTITLE"
417	local prompt # Calculated below
418	local hline="$hline_arrows_tab_enter"
419
420	local height=8 width=50 prefix="   "
421	local plen=${#prefix} list= line=
422	local max_width=$(( $width - 3 - $plen ))
423
424	local yes no defaultno extra_args format
425	if [ "$USE_XDIALOG" ]; then
426		yes=ok no=cancel defaultno=default-no
427		extra_args="--wrap --left"
428		format="$msg_last_chance_are_you_sure"
429	else
430		yes=yes no=no defaultno=defaultno
431		extra_args="--colors --cr-wrap"
432		format="$msg_last_chance_are_you_sure_color"
433	fi
434
435	local disk line_width
436	for disk in $*; do
437		if [ "$line" ]; then
438			line_width=${#line}
439		else
440			line_width=$plen
441		fi
442		line_width=$(( $line_width + 1 + ${#disk} ))
443		# Add newline before disk if it would exceed max_width
444		if [ $line_width -gt $max_width ]; then
445			list="$list$line\n"
446			line="$prefix"
447			height=$(( $height + 1 ))
448		fi
449		# Add the disk to the list
450		line="$line $disk"
451	done
452	# Append the left-overs
453	if [ "${line#$prefix}" ]; then
454		list="$list$line"
455		height=$(( $height + 1 ))
456	fi
457
458	# Add height for Xdialog(1)
459	[ "$USE_XDIALOG" ] && height=$(( $height + $height / 5 + 3 ))
460
461	prompt=$( printf "$format" "$list" )
462	f_dprintf "%s: Last Chance!" "$0"
463	$DIALOG \
464		--title "$title"        \
465		--backtitle "$btitle"   \
466		--hline "$hline"        \
467		--$defaultno            \
468		--$yes-label "$msg_yes" \
469		--$no-label "$msg_no"   \
470		$extra_args             \
471		--yesno "$prompt" $height $width
472}
473
474# dialog_menu_layout
475#
476# Configure Virtual Device type and disks to use for the ZFS boot pool. User
477# must select enough disks to satisfy the chosen vdev type.
478#
479dialog_menu_layout()
480{
481	local funcname=dialog_menu_layout
482	local title="$DIALOG_TITLE"
483	local btitle="$DIALOG_BACKTITLE"
484	local vdev_prompt="$msg_select_virtual_device_type"
485	local disk_prompt="$msg_please_select_one_or_more_disks"
486	local vdev_menu_list="
487		'stripe' '$msg_stripe_desc' '$msg_stripe_help'
488		'mirror' '$msg_mirror_desc' '$msg_mirror_help'
489		'raid10' '$msg_raid10_desc' '$msg_raid10_help'
490		'raidz1' '$msg_raidz1_desc' '$msg_raidz1_help'
491		'raidz2' '$msg_raidz2_desc' '$msg_raidz2_help'
492		'raidz3' '$msg_raidz3_desc' '$msg_raidz3_help'
493	" # END-QUOTE
494	local disk_check_list= # Calculated below
495	local vdev_hline="$hline_arrows_tab_enter"
496	local disk_hline="$hline_arrows_space_tab_enter"
497
498	# Warn the user if vdev type is not valid
499	case "$ZFSBOOT_VDEV_TYPE" in
500	stripe|mirror|raid10|raidz1|raidz2|raidz3) : known good ;;
501	*)
502		f_dprintf "%s: Invalid virtual device type \`%s'" \
503			  $funcname "$ZFSBOOT_VDEV_TYPE"
504		f_show_err "$msg_invalid_virtual_device_type" \
505			   "$ZFSBOOT_VDEV_TYPE"
506		f_interactive || return $FAILURE
507	esac
508
509	# Calculate size of vdev menu once only
510	local vheight vwidth vrows
511	eval f_dialog_menu_with_help_size vheight vwidth vrows \
512		\"\$title\" \"\$btitle\" \"\$vdev_prompt\" \"\$vdev_hline\" \
513		$vdev_menu_list
514
515	# Get a list of probed disk devices
516	local disks=
517	debug= f_device_find "" $DEVICE_TYPE_DISK disks
518
519	# Prune out mounted md(4) devices that may be part of the boot process
520	local disk name new_list=
521	for disk in $disks; do
522		debug= $disk get name name
523		case "$name" in
524		md[0-9]*) f_mounted -b "/dev/$name" && continue ;;
525		esac
526		new_list="$new_list $disk"
527	done
528	disks="${new_list# }"
529
530	# Debugging
531	if [ "$debug" ]; then
532		local disk_names=
533		for disk in $disks; do
534			debug= $disk get name name
535			disk_names="$disk_names $name"
536		done
537		f_dprintf "$funcname: disks=[%s]" "${disk_names# }"
538	fi
539
540	if [ ! "$disks" ]; then
541		f_dprintf "No disk(s) present to configure"
542		f_show_err "$msg_no_disks_present_to_configure"
543		return $FAILURE
544	fi
545
546	# Lets sort the disks array to be more user friendly
547	f_device_sort_by name disks disks
548
549	#
550	# Operate in a loop so we can (if interactive) repeat if not enough
551	# disks are selected to satisfy the chosen vdev type or user wants to
552	# back-up to the previous menu.
553	#
554	local vardisk ndisks onoff selections vdev_choice breakout device
555	local valid_disks all_valid want_disks desc height width rows
556	while :; do
557		#
558		# Confirm the vdev type that was selected
559		#
560		if f_interactive && [ "$ZFSBOOT_CONFIRM_LAYOUT" ]; then
561			vdev_choice=$( eval $DIALOG \
562				--title \"\$title\"              \
563				--backtitle \"\$btitle\"         \
564				--hline \"\$vdev_hline\"         \
565				--ok-label \"\$msg_ok\"          \
566				--cancel-label \"\$msg_cancel\"  \
567				--item-help                      \
568				--default-item \"\$ZFSBOOT_VDEV_TYPE\" \
569				--menu \"\$vdev_prompt\"         \
570				$vheight $vwidth $vrows          \
571				$vdev_menu_list                  \
572				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
573			) || return $?
574				# Exit if user pressed ESC or chose Cancel/No
575			f_dialog_data_sanitize vdev_choice
576
577			ZFSBOOT_VDEV_TYPE="$vdev_choice"
578			f_dprintf "$funcname: ZFSBOOT_VDEV_TYPE=[%s]" \
579			          "$ZFSBOOT_VDEV_TYPE"
580		fi
581
582		# Determine the number of disks needed for this vdev type
583		want_disks=0
584		case "$ZFSBOOT_VDEV_TYPE" in
585		stripe) want_disks=1 ;;
586		mirror) want_disks=2 ;;
587		raid10) want_disks=4 ;;
588		raidz1) want_disks=3 ;;
589		raidz2) want_disks=4 ;;
590		raidz3) want_disks=5 ;;
591		esac
592
593		#
594		# Warn the user if any scripted disks are invalid
595		#
596		valid_disks= all_valid=${ZFSBOOT_DISKS:+1} # optimism
597		for disk in $ZFSBOOT_DISKS; do
598			if debug= f_device_find -1 \
599				$disk $DEVICE_TYPE_DISK device
600			then
601				valid_disks="$valid_disks $disk"
602				continue
603			fi
604			f_dprintf "$funcname: \`%s' is not a real disk" "$disk"
605			all_valid=
606		done
607		if [ ! "$all_valid" ]; then
608			if [ "$ZFSBOOT_DISKS" ]; then
609				f_show_err \
610				    "$msg_missing_one_or_more_scripted_disks"
611			else
612				f_dprintf "No disks selected."
613				f_interactive ||
614					f_show_err "$msg_no_disks_selected"
615			fi
616			f_interactive || return $FAILURE
617		fi
618		ZFSBOOT_DISKS="${valid_disks# }"
619
620		#
621		# Short-circuit if we're running non-interactively
622		#
623		if ! f_interactive || [ ! "$ZFSBOOT_CONFIRM_LAYOUT" ]; then
624			f_count ndisks $ZFSBOOT_DISKS
625			[ $ndisks -ge $want_disks ] && break # to success
626
627			# Not enough disks selected
628			f_dprintf "$funcname: %s: %s (%u < %u minimum)" \
629				  "$ZFSBOOT_VDEV_TYPE" \
630				  "Not enough disks selected." \
631				  $ndisks $want_disks
632			f_interactive || return $FAILURE
633			msg_yes="$msg_change_selection" msg_no="$msg_cancel" \
634				f_yesno "%s: $msg_not_enough_disks_selected" \
635				"$ZFSBOOT_VDEV_TYPE" $ndisks $want_disks ||
636				return $FAILURE
637		fi
638
639		#
640		# Confirm the disks that were selected
641		# Loop until the user cancels or selects enough disks
642		#
643		breakout=
644		while :; do
645			# Loop over list of available disks, resetting state
646			for disk in $disks; do
647				f_isset _${disk}_status && _${disk}_status=
648			done
649
650			# Loop over list of selected disks and create temporary
651			# locals to map statuses onto up-to-date list of disks
652			for disk in $ZFSBOOT_DISKS; do
653				debug= f_device_find -1 \
654					$disk $DEVICE_TYPE_DISK disk
655				f_isset _${disk}_status ||
656					local _${disk}_status
657				_${disk}_status=on
658			done
659
660			# Create the checklist menu of discovered disk devices
661			disk_check_list=
662			for disk in $disks; do
663				desc=
664				$disk get name name
665				$disk get desc desc
666				f_shell_escape "$desc" desc
667				f_getvar _${disk}_status:-off onoff
668				disk_check_list="$disk_check_list
669					$name '$desc' $onoff"
670			done
671
672			eval f_dialog_checklist_size height width rows \
673				\"\$title\" \"\$btitle\" \"\$prompt\" \
674				\"\$hline\" $disk_check_list
675
676			selections=$( eval $DIALOG \
677				--title \"\$DIALOG_TITLE\"         \
678				--backtitle \"\$DIALOG_BACKTITLE\" \
679				--separate-output                  \
680				--hline \"\$hline\"                \
681				--ok-label \"\$msg_ok\"            \
682				--cancel-label \"\$msg_back\"      \
683				--checklist \"\$prompt\"           \
684				$height $width $rows               \
685				$disk_check_list                   \
686				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
687			) || break
688				# Loop if user pressed ESC or chose Cancel/No
689			f_dialog_data_sanitize selections
690
691			ZFSBOOT_DISKS="$selections"
692			f_dprintf "$funcname: ZFSBOOT_DISKS=[%s]" \
693			          "$ZFSBOOT_DISKS"
694
695			f_count ndisks $ZFSBOOT_DISKS
696
697			if [ "$ZFSBOOT_VDEV_TYPE" == "raid10" ] &&
698			    [ $(( $ndisks % 2 )) -ne 0 ]; then
699				f_dprintf "$funcname: %s: %s (%u %% 2 = %u)" \
700					  "$ZFSBOOT_VDEV_TYPE" \
701					  "Number of disks not even:" \
702					  $ndisks $(( $ndisks % 2 ))
703				msg_yes="$msg_change_selection" \
704					msg_no="$msg_cancel" \
705					f_yesno "%s: $msg_odd_disk_selected" \
706						"$ZFSBOOT_VDEV_TYPE" $ndisks ||
707						break
708				continue
709			fi
710
711			[ $ndisks -ge $want_disks ] &&
712				breakout=break && break
713
714			# Not enough disks selected
715			f_dprintf "$funcname: %s: %s (%u < %u minimum)" \
716				  "$ZFSBOOT_VDEV_TYPE" \
717			          "Not enough disks selected." \
718			          $ndisks $want_disks
719			msg_yes="$msg_change_selection" msg_no="$msg_cancel" \
720				f_yesno "%s: $msg_not_enough_disks_selected" \
721				"$ZFSBOOT_VDEV_TYPE" $ndisks $want_disks ||
722				break
723		done
724		[ "$breakout" = "break" ] && break
725		[ "$ZFSBOOT_CONFIRM_LAYOUT" ] || return $FAILURE
726	done
727
728	return $DIALOG_OK
729}
730
731# zfs_create_diskpart $disk $index
732#
733# For each block device to be used in the zpool, rather than just create the
734# zpool with the raw block devices (e.g., da0, da1, etc.) we create partitions
735# so we can have some real swap. This also provides wiggle room incase your
736# replacement drivers do not have the exact same sector counts.
737#
738# NOTE: $swapsize and $bootsize should be defined by the calling function.
739# NOTE: Sets $bootpart and $targetpart for the calling function.
740#
741zfs_create_diskpart()
742{
743	local funcname=zfs_create_diskpart
744	local disk="$1" index="$2"
745
746	# Check arguments
747	if [ ! "$disk" ]; then
748		f_dprintf "$funcname: NULL disk argument"
749		msg_error="$msg_error: $funcname" \
750			f_show_err "$msg_null_disk_argument"
751		return $FAILURE
752	fi
753	if [ "${disk#*[$IFS]}" != "$disk" ]; then
754		f_dprintf "$funcname: Invalid disk argument \`%s'" "$disk"
755		msg_error="$msg_error: $funcname" \
756			f_show_err "$msg_invalid_disk_argument" "$disk"
757		return $FAILURE
758	fi
759	if [ ! "$index" ]; then
760		f_dprintf "$funcname: NULL index argument"
761		msg_error="$msg_error: $funcname" \
762			f_show_err "$msg_null_index_argument"
763		return $FAILURE
764	fi
765	if ! f_isinteger "$index"; then
766		f_dprintf "$funcname: Invalid index argument \`%s'" "$index"
767		msg_error="$msg_error: $funcname" \
768			f_show_err "$msg_invalid_index_argument" "$index"
769		return $FAILURE
770	fi
771	f_dprintf "$funcname: disk=[%s] index=[%s]" "$disk" "$index"
772
773	# Check for unknown partition scheme before proceeding further
774	case "$ZFSBOOT_PARTITION_SCHEME" in
775	""|MBR|GPT*) : known good ;;
776	*)
777		f_dprintf "$funcname: %s is an unsupported partition scheme" \
778		          "$ZFSBOOT_PARTITION_SCHEME"
779		msg_error="$msg_error: $funcname" f_show_err \
780			"$msg_unsupported_partition_scheme" \
781			"$ZFSBOOT_PARTITION_SCHEME"
782		return $FAILURE
783	esac
784
785	#
786	# Destroy whatever partition layout is currently on disk.
787	# NOTE: `-F' required to destroy if partitions still exist.
788	# NOTE: Failure is ok here, blank disk will have nothing to destroy.
789	#
790	f_dprintf "$funcname: Exporting ZFS pools..."
791	zpool list -Ho name | while read z_name; do
792		f_eval_catch -d $funcname zpool "$ZPOOL_EXPORT_F" $z_name
793	done
794	f_dprintf "$funcname: Detaching all GELI providers..."
795	geli status | tail -n +2 | while read g_name g_status g_component; do
796		f_eval_catch -d $funcname geli "$GELI_DETACH_F" $g_name
797	done
798	f_dprintf "$funcname: Destroying all data/layouts on \`%s'..." "$disk"
799	f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" $disk
800	f_eval_catch -d $funcname graid "$GRAID_DELETE" $disk
801	f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" /dev/$disk
802
803	# Make doubly-sure backup GPT is destroyed
804	f_eval_catch -d $funcname gpart "$GPART_CREATE" gpt $disk
805	f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" $disk
806
807	#
808	# Lay down the desired type of partition scheme
809	#
810	local setsize mbrindex align_small align_big
811	#
812	# If user has requested 4 K alignment, add these params to the
813	# gpart add calls. With GPT, we align large partitions to 1 M for
814	# improved performance on SSDs. MBR does not always play well with gaps
815	# between partitions, so all alignment is only 4k for that case.
816	# With MBR, we align the BSD partition that contains the MBR, otherwise
817	# the system fails to boot.
818	#
819	if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
820		align_small="-a 4k"
821		align_big="-a 1m"
822	fi
823
824	case "$ZFSBOOT_PARTITION_SCHEME" in
825	""|GPT*) f_dprintf "$funcname: Creating GPT layout..."
826		#
827		# 1. Create GPT layout using labels
828		#
829		f_eval_catch $funcname gpart "$GPART_CREATE" gpt $disk ||
830		             return $FAILURE
831
832		#
833		# Apply workarounds if requested by the user
834		#
835		if [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT + Lenovo Fix" ]; then
836			f_eval_catch $funcname gpart "$GPART_SET_LENOVOFIX" \
837			             $disk || return $FAILURE
838		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT + Active" ]; then
839			f_eval_catch $funcname gpart "$GPART_SET_PMBR_ACTIVE" \
840			             $disk || return $FAILURE
841		fi
842
843		#
844		# 2. Add small freebsd-boot and/or efi partition
845		#
846		if [ "$ZFSBOOT_BOOT_TYPE" = "UEFI" -o \
847		     "$ZFSBOOT_BOOT_TYPE" = "BIOS+UEFI" ]
848		then
849			f_eval_catch -k justaddedpart $funcname gpart \
850			             "$GPART_ADD_ALIGN_LABEL_WITH_SIZE" \
851			             "$align_small" efiboot$index efi 260M \
852			             $disk || return $FAILURE
853
854			# We'll configure the ESP in bootconfig
855			if [ -z "$efibootpart" ]; then
856				efibootpart="/dev/$(echo $justaddedpart | cut -f 1 -d ' ')"
857				f_dprintf "$funcname: configuring ESP at [%s]" \
858				          "${efibootpart}"
859
860				f_eval_catch $funcname newfs_msdos "$NEWFS_ESP"\
861				             "$efibootpart" \
862				             || return $FAILURE
863				f_eval_catch $funcname printf "$PRINTF_FSTAB" \
864					     $efibootpart /boot/efi msdosfs \
865				             rw 2 2 "$BSDINSTALL_TMPETC/fstab" \
866				             || return $FAILURE
867			fi
868		fi
869
870		if [ "$ZFSBOOT_BOOT_TYPE" = "BIOS" -o \
871		     "$ZFSBOOT_BOOT_TYPE" = "BIOS+UEFI" ]
872		then
873			f_eval_catch $funcname gpart \
874			             "$GPART_ADD_ALIGN_LABEL_WITH_SIZE" \
875			             "$align_small" gptboot$index \
876			             freebsd-boot 512k $disk || return $FAILURE
877			if [ "$ZFSBOOT_BOOT_TYPE" = "BIOS" ]; then
878				f_eval_catch $funcname gpart \
879				             "$GPART_BOOTCODE_PART" \
880				             /boot/pmbr /boot/gptzfsboot 1 \
881				             $disk || return $FAILURE
882			else
883				f_eval_catch $funcname gpart \
884				             "$GPART_BOOTCODE_PART" \
885				             /boot/pmbr /boot/gptzfsboot 2 \
886				             $disk || return $FAILURE
887			fi
888		fi
889
890		# NB: zpool will use the `zfs#' GPT labels
891		if [ "$ZFSBOOT_BOOT_TYPE" = "BIOS+UEFI" ]; then
892			if [ "$ZFSBOOT_BOOT_POOL" ]; then
893				bootpart=p3 swappart=p4 targetpart=p4
894				[ ${swapsize:-0} -gt 0 ] && targetpart=p5
895			else
896				# Bootpart unused
897				bootpart=p3 swappart=p3 targetpart=p3
898				[ ${swapsize:-0} -gt 0 ] && targetpart=p4
899			fi
900		else
901			if [ "$ZFSBOOT_BOOT_POOL" ]; then
902				bootpart=p2 swappart=p3 targetpart=p3
903				[ ${swapsize:-0} -gt 0 ] && targetpart=p4
904			else
905				# Bootpart unused
906				bootpart=p2 swappart=p2 targetpart=p2
907				[ ${swapsize:-0} -gt 0 ] && targetpart=p3
908			fi
909		fi
910
911		#
912		# Prepare boot pool if enabled (e.g., for geli(8))
913		#
914		if [ "$ZFSBOOT_BOOT_POOL" ]; then
915			f_eval_catch $funcname gpart \
916			             "$GPART_ADD_ALIGN_LABEL_WITH_SIZE" \
917			             "$align_big" boot$index freebsd-zfs \
918			             ${bootsize}b $disk || return $FAILURE
919			# Pedantically nuke any old labels
920			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
921			                /dev/$disk$bootpart
922			if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
923				# Pedantically detach targetpart for later
924				f_eval_catch -d $funcname geli \
925				                "$GELI_DETACH_F" \
926				                /dev/$disk$targetpart
927			fi
928		fi
929
930		#
931		# 3. Add freebsd-swap partition labeled `swap#'
932		#
933		if [ ${swapsize:-0} -gt 0 ]; then
934			f_eval_catch $funcname gpart \
935			             "$GPART_ADD_ALIGN_LABEL_WITH_SIZE" \
936			             "$align_big" swap$index freebsd-swap \
937			             ${swapsize}b $disk || return $FAILURE
938			# Pedantically nuke any old labels on the swap
939			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
940			                /dev/$disk$swappart
941		fi
942
943		#
944		# 4. Add freebsd-zfs partition labeled `zfs#' for zroot
945		#
946		f_eval_catch $funcname gpart "$GPART_ADD_ALIGN_LABEL" \
947		             "$align_big" zfs$index freebsd-zfs $disk ||
948		             return $FAILURE
949		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
950		                /dev/$disk$targetpart
951		;;
952
953	MBR) f_dprintf "$funcname: Creating MBR layout..."
954		#
955		# Enable boot pool if encryption is desired
956		#
957		[ "$ZFSBOOT_GELI_ENCRYPTION" ] && ZFSBOOT_BOOT_POOL=1
958		#
959		# 1. Create MBR layout (no labels)
960		#
961		f_eval_catch $funcname gpart "$GPART_CREATE" mbr $disk ||
962		             return $FAILURE
963		f_eval_catch $funcname gpart "$GPART_BOOTCODE" /boot/mbr \
964		             $disk || return $FAILURE
965
966		#
967		# 2. Add freebsd slice with all available space
968		#
969		f_eval_catch $funcname gpart "$GPART_ADD_ALIGN" \
970		             "$align_small" freebsd $disk || return $FAILURE
971		f_eval_catch $funcname gpart "$GPART_SET_ACTIVE" 1 $disk ||
972		             return $FAILURE
973		# Pedantically nuke any old labels
974		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
975		                /dev/${disk}s1
976		# Pedantically nuke any old scheme
977		f_eval_catch -d $funcname gpart "$GPART_DESTROY_F" ${disk}s1
978
979		#
980		# 3. Write BSD scheme to the freebsd slice
981		#
982		f_eval_catch $funcname gpart "$GPART_CREATE" BSD ${disk}s1 ||
983		             return $FAILURE
984
985		# NB: zpool will use s1a (no labels)
986		bootpart=s1a swappart=s1b targetpart=s1d mbrindex=4
987
988		#
989		# Always prepare a boot pool on MBR
990		# Do not align this partition, there must not be a gap
991		#
992		ZFSBOOT_BOOT_POOL=1
993		f_eval_catch $funcname gpart \
994		             "$GPART_ADD_ALIGN_INDEX_WITH_SIZE" \
995		             "" 1 freebsd-zfs ${bootsize}b ${disk}s1 ||
996		             return $FAILURE
997		# Pedantically nuke any old labels
998		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
999		                /dev/$disk$bootpart
1000		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1001			# Pedantically detach targetpart for later
1002			f_eval_catch -d $funcname geli \
1003			                "$GELI_DETACH_F" \
1004					/dev/$disk$targetpart
1005		fi
1006
1007		#
1008		# 4. Add freebsd-swap partition
1009		#
1010		if [ ${swapsize:-0} -gt 0 ]; then
1011			f_eval_catch $funcname gpart \
1012			             "$GPART_ADD_ALIGN_INDEX_WITH_SIZE" \
1013			             "$align_small" 2 freebsd-swap \
1014			             ${swapsize}b ${disk}s1 || return $FAILURE
1015			# Pedantically nuke any old labels on the swap
1016			f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
1017			                /dev/${disk}s1b
1018		fi
1019
1020		#
1021		# 5. Add freebsd-zfs partition for zroot
1022		#
1023		f_eval_catch $funcname gpart "$GPART_ADD_ALIGN_INDEX" \
1024		             "$align_small" $mbrindex freebsd-zfs ${disk}s1 ||
1025		             return $FAILURE
1026		f_eval_catch -d $funcname zpool "$ZPOOL_LABELCLEAR_F" \
1027		                /dev/$disk$targetpart # Pedantic
1028		f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
1029		             /boot/zfsboot /dev/${disk}s1 count=1 ||
1030		             return $FAILURE
1031		;;
1032
1033	esac # $ZFSBOOT_PARTITION_SCHEME
1034
1035	# Update fstab(5)
1036	local swapsize
1037	f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize
1038	if [ "$isswapmirror" ]; then
1039		# This is not the first disk in the mirror, do nothing
1040	elif [ ${swapsize:-0} -eq 0 ]; then
1041		# If swap is 0 sized, don't add it to fstab
1042	elif [ "$ZFSBOOT_SWAP_ENCRYPTION" -a "$ZFSBOOT_SWAP_MIRROR" ]; then
1043		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1044		             /dev/mirror/swap.eli none swap sw 0 0 \
1045		             $BSDINSTALL_TMPETC/fstab || return $FAILURE
1046		isswapmirror=1
1047	elif [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1048		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1049		             /dev/mirror/swap none swap sw 0 0 \
1050		             $BSDINSTALL_TMPETC/fstab || return $FAILURE
1051		isswapmirror=1
1052	elif [ "$ZFSBOOT_SWAP_ENCRYPTION" ]; then
1053		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1054		             /dev/$disk${swappart}.eli none swap sw 0 0 \
1055		             $BSDINSTALL_TMPETC/fstab || return $FAILURE
1056	else
1057		f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1058		             /dev/$disk$swappart none swap sw 0 0 \
1059		             $BSDINSTALL_TMPETC/fstab || return $FAILURE
1060	fi
1061
1062	return $SUCCESS
1063}
1064
1065# zfs_create_boot $poolname $vdev_type $disks ...
1066#
1067# Creates boot pool and dataset layout. Returns error if something goes wrong.
1068# Errors are printed to stderr for collection and display.
1069#
1070zfs_create_boot()
1071{
1072	local funcname=zfs_create_boot
1073	local zroot_name="$1"
1074	local zroot_vdevtype="$2"
1075	local zroot_vdevs= # Calculated below
1076	local swap_devs= # Calculated below
1077	local boot_vdevs= # Used for geli(8) and/or MBR layouts
1078	shift 2 # poolname vdev_type
1079	local disks="$*" disk
1080	local isswapmirror
1081	local bootpart targetpart swappart # Set by zfs_create_diskpart() below
1082	local create_options
1083	local efibootpart
1084
1085	#
1086	# Pedantic checks; should never be seen
1087	#
1088	if [ ! "$zroot_name" ]; then
1089		f_dprintf "$funcname: NULL poolname"
1090		msg_error="$msg_error: $funcname" \
1091			f_show_err "$msg_null_poolname"
1092		return $FAILURE
1093	fi
1094	if [ $# -lt 1 ]; then
1095		f_dprintf "$funcname: missing disk arguments"
1096		msg_error="$msg_error: $funcname" \
1097			f_show_err "$msg_missing_disk_arguments"
1098		return $FAILURE
1099	fi
1100	f_dprintf "$funcname: poolname=[%s] vdev_type=[%s]" \
1101	          "$zroot_name" "$zroot_vdevtype"
1102
1103	#
1104	# Initialize fstab(5)
1105	#
1106	f_dprintf "$funcname: Initializing temporary fstab(5) file..."
1107	f_eval_catch $funcname sh "$SHELL_TRUNCATE" $BSDINSTALL_TMPETC/fstab ||
1108	             return $FAILURE
1109	f_eval_catch $funcname printf "$PRINTF_FSTAB" \
1110	             "# Device" Mountpoint FStype Options Dump "Pass#" \
1111	             $BSDINSTALL_TMPETC/fstab || return $FAILURE
1112
1113	#
1114	# Expand SI units in desired sizes
1115	#
1116	f_dprintf "$funcname: Expanding supplied size values..."
1117	local swapsize bootsize
1118	if ! f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize; then
1119		f_dprintf "$funcname: Invalid swap size \`%s'" \
1120		          "$ZFSBOOT_SWAP_SIZE"
1121		f_show_err "$msg_invalid_swap_size" "$ZFSBOOT_SWAP_SIZE"
1122		return $FAILURE
1123	fi
1124	if ! f_expand_number "$ZFSBOOT_BOOT_POOL_SIZE" bootsize; then
1125		f_dprintf "$funcname: Invalid boot pool size \`%s'" \
1126		          "$ZFSBOOT_BOOT_POOL_SIZE"
1127		f_show_err "$msg_invalid_boot_pool_size" \
1128		           "$ZFSBOOT_BOOT_POOL_SIZE"
1129		return $FAILURE
1130	fi
1131	f_dprintf "$funcname: ZFSBOOT_SWAP_SIZE=[%s] swapsize=[%s]" \
1132	          "$ZFSBOOT_SWAP_SIZE" "$swapsize"
1133	f_dprintf "$funcname: ZFSBOOT_BOOT_POOL_SIZE=[%s] bootsize=[%s]" \
1134	          "$ZFSBOOT_BOOT_POOL_SIZE" "$bootsize"
1135
1136	#
1137	# Destroy the pool in-case this is our second time 'round (case of
1138	# failure and installer presented ``Retry'' option to come back).
1139	#
1140	# NB: If we don't destroy the pool, later gpart(8) destroy commands
1141	# that try to clear existing partitions (see zfs_create_diskpart())
1142	# will fail with a `Device Busy' error, leading to `GEOM exists'.
1143	#
1144	f_eval_catch -d $funcname zpool "$ZPOOL_DESTROY" "$zroot_name"
1145
1146	#
1147	# Prepare the disks and build pool device list(s)
1148	#
1149	f_dprintf "$funcname: Preparing disk partitions for ZFS pool..."
1150
1151	# Force 4K sectors using vfs.zfs.min_auto_ashift=12
1152	if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
1153		f_dprintf "$funcname: With 4K sectors..."
1154		f_eval_catch $funcname sysctl "$SYSCTL_ZFS_MIN_ASHIFT_12" \
1155		    || return $FAILURE
1156		sysctl kern.geom.part.mbr.enforce_chs=0
1157	fi
1158	local n=0
1159	for disk in $disks; do
1160		zfs_create_diskpart $disk $n || return $FAILURE
1161		# Now $bootpart, $targetpart, and $swappart are set (suffix
1162		# for $disk)
1163		if [ "$ZFSBOOT_BOOT_POOL" ]; then
1164			boot_vdevs="$boot_vdevs $disk$bootpart"
1165		fi
1166		zroot_vdevs="$zroot_vdevs $disk$targetpart"
1167		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1168			zroot_vdevs="$zroot_vdevs.eli"
1169		fi
1170
1171		n=$(( $n + 1 ))
1172	done # disks
1173
1174	#
1175	# If we need/want a boot pool, create it
1176	#
1177	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1178		local bootpool_vdevtype= # Calculated below
1179		local bootpool_options= # Calculated below
1180		local bootpool_name="$ZFSBOOT_BOOT_POOL_NAME"
1181		local bootpool="$BSDINSTALL_CHROOT/$bootpool_name"
1182		local zroot_key="${ZFSBOOT_GELI_KEY_FILE#/}"
1183
1184		f_dprintf "$funcname: Setting up boot pool..."
1185		[ "$ZFSBOOT_GELI_ENCRYPTION" ] &&
1186			f_dprintf "$funcname: For encrypted root disk..."
1187
1188		# Create parent directory for boot pool
1189		f_eval_catch -d $funcname umount "$UMOUNT" "$BSDINSTALL_CHROOT"
1190		f_eval_catch $funcname mount "$MOUNT_TYPE" tmpfs none \
1191		             $BSDINSTALL_CHROOT || return $FAILURE
1192
1193		# Create mirror across the boot partition on all disks
1194		local nvdevs
1195		f_count nvdevs $boot_vdevs
1196		[ $nvdevs -gt 1 ] && bootpool_vdevtype=mirror
1197
1198		create_options="$ZFSBOOT_BOOT_POOL_CREATE_OPTIONS"
1199		bootpool_options="-o altroot=$BSDINSTALL_CHROOT"
1200		bootpool_options="$bootpool_options $create_options"
1201		bootpool_options="$bootpool_options -m \"/$bootpool_name\" -f"
1202		f_eval_catch $funcname zpool "$ZPOOL_CREATE_WITH_OPTIONS" \
1203		             "$bootpool_options" "$bootpool_name" \
1204		             "$bootpool_vdevtype" "$boot_vdevs" ||
1205		             return $FAILURE
1206
1207		f_eval_catch $funcname mkdir "$MKDIR_P" "$bootpool/boot" ||
1208		             return $FAILURE
1209
1210		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1211			# Generate an encryption key using random(4)
1212			f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
1213			             /dev/random "$bootpool/$zroot_key" \
1214			             "bs=4096 count=1" || return $FAILURE
1215			f_eval_catch $funcname chmod "$CHMOD_MODE" \
1216			             go-wrx "$bootpool/$zroot_key" ||
1217			             return $FAILURE
1218		fi
1219
1220	fi
1221
1222	#
1223	# Create the geli(8) GEOMS
1224	#
1225	if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1226		#
1227		# Load the AES-NI kernel module to accelerate encryption
1228		#
1229		f_eval_catch -d $funcname kldload "$KLDLOAD" "aesni"
1230		# Prompt user for password (twice)
1231		if ! msg_enter_new_password="$msg_geli_password" \
1232			f_dialog_input_password
1233		then
1234			f_dprintf "$funcname: User cancelled"
1235			f_show_err "$msg_user_cancelled"
1236			return $FAILURE
1237		fi
1238
1239		# Initialize geli(8) on each of the target partitions
1240		for disk in $disks; do
1241			f_dialog_info "$msg_geli_setup" \
1242				2>&1 >&$DIALOG_TERMINAL_PASSTHRU_FD
1243			if [ "$ZFSBOOT_BOOT_POOL" ]; then
1244				if ! echo "$pw_password" | f_eval_catch \
1245					$funcname geli "$GELI_PASSWORD_INIT" \
1246					"$bootpool/boot/$disk$targetpart.eli" \
1247					AES-XTS "$bootpool/$zroot_key" \
1248					$disk$targetpart
1249				then
1250					f_interactive || f_die
1251					unset pw_password # Sensitive info
1252					return $FAILURE
1253				fi
1254				if ! echo "$pw_password" | f_eval_catch \
1255					$funcname geli "$GELI_ATTACH" \
1256					"$bootpool/$zroot_key" $disk$targetpart
1257				then
1258					f_interactive || f_die
1259					unset pw_password # Sensitive info
1260					return $FAILURE
1261				fi
1262			else
1263				# With no bootpool, there is no place to store
1264				# the key files, use only a password
1265				if ! echo "$pw_password" | f_eval_catch \
1266					$funcname geli \
1267					"$GELI_PASSWORD_GELIBOOT_INIT" \
1268					AES-XTS $disk$targetpart
1269				then
1270					f_interactive || f_die
1271					unset pw_password # Sensitive info
1272					return $FAILURE
1273				fi
1274				if ! echo "$pw_password" | f_eval_catch \
1275					$funcname geli "$GELI_ATTACH_NOKEY" \
1276					$disk$targetpart
1277				then
1278					f_interactive || f_die
1279					unset pw_password # Sensitive info
1280					return $FAILURE
1281				fi
1282			fi
1283		done
1284		unset pw_password # Sensitive info
1285	fi
1286
1287	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1288		# Clean up
1289		f_eval_catch $funcname zfs "$ZFS_UNMOUNT" "$bootpool_name" ||
1290			return $FAILURE
1291		# tmpfs
1292		f_eval_catch -d $funcname umount "$UMOUNT" "$BSDINSTALL_CHROOT"
1293	fi
1294
1295	#
1296	# Create the gmirror(8) GEOMS for swap
1297	#
1298	if [ ${swapsize:-0} -gt 0 -a "$ZFSBOOT_SWAP_MIRROR" ]; then
1299		for disk in $disks; do
1300			swap_devs="$swap_devs $disk$swappart"
1301		done
1302		f_eval_catch $funcname gmirror "$SWAP_GMIRROR_LABEL" \
1303			"$swap_devs" || return $FAILURE
1304	fi
1305
1306	#
1307	# Create the ZFS root pool with desired type and disk devices
1308	#
1309	f_dprintf "$funcname: Creating root pool..."
1310	create_options="$ZFSBOOT_POOL_CREATE_OPTIONS"
1311	if [ "$zroot_vdevtype" == "raid10" ]; then
1312		raid10_vdevs=""
1313		for vdev in $zroot_vdevs; do
1314			f_count nvdev $raid10_vdevs
1315			if [ $(( $nvdev % 3 )) -eq 0 ]; then
1316				raid10_vdevs="$raid10_vdevs mirror"
1317			fi
1318			raid10_vdevs="$raid10_vdevs $vdev"
1319		done
1320		f_eval_catch $funcname zpool "$ZPOOL_CREATE_WITH_OPTIONS" \
1321			"-o altroot=$BSDINSTALL_CHROOT $create_options -m none -f" \
1322			"$zroot_name" "" "$raid10_vdevs" || return $FAILURE
1323	else
1324		f_eval_catch $funcname zpool "$ZPOOL_CREATE_WITH_OPTIONS" \
1325			"-o altroot=$BSDINSTALL_CHROOT $create_options -m none -f" \
1326			"$zroot_name" "$zroot_vdevtype" "$zroot_vdevs" ||
1327			return $FAILURE
1328	fi
1329
1330	#
1331	# Create ZFS dataset layout within the new root pool
1332	#
1333	f_dprintf "$funcname: Creating ZFS datasets..."
1334	echo "$ZFSBOOT_DATASETS" | while read dataset options; do
1335		# Skip blank lines and comments
1336		case "$dataset" in "#"*|"") continue; esac
1337		# Remove potential inline comments in options
1338		options="${options%%#*}"
1339		# Replace tabs with spaces
1340		f_replaceall "$options" "	" " " options
1341		# Reduce contiguous runs of space to one single space
1342		oldoptions=
1343		while [ "$oldoptions" != "$options" ]; do
1344			oldoptions="$options"
1345			f_replaceall "$options" "  " " " options
1346		done
1347		# Replace both commas and spaces with ` -o '
1348		f_replaceall "$options" "[ ,]" " -o " options
1349		# Create the dataset with desired options
1350		f_eval_catch $funcname zfs "$ZFS_CREATE_WITH_OPTIONS" \
1351		             "${options:+-o $options}" "$zroot_name$dataset" ||
1352		             return $FAILURE
1353	done
1354
1355	#
1356	# Set a mountpoint for the root of the pool so newly created datasets
1357	# have a mountpoint to inherit
1358	#
1359	f_dprintf "$funcname: Setting mountpoint for root of the pool..."
1360	f_eval_catch $funcname zfs "$ZFS_SET" \
1361		"mountpoint=/$zroot_name" "$zroot_name" || return $FAILURE
1362
1363	# Touch up permissions on the tmp directories
1364	f_dprintf "$funcname: Modifying directory permissions..."
1365	local dir
1366	for dir in /tmp /var/tmp; do
1367		f_eval_catch $funcname mkdir "$MKDIR_P" \
1368		             $BSDINSTALL_CHROOT$dir || return $FAILURE
1369		f_eval_catch $funcname chmod "$CHMOD_MODE" 1777 \
1370		             $BSDINSTALL_CHROOT$dir || return $FAILURE
1371	done
1372
1373	# Set bootfs property
1374	local zroot_bootfs="$ZFSBOOT_BEROOT_NAME/$ZFSBOOT_BOOTFS_NAME"
1375	f_dprintf "$funcname: Setting bootfs property..."
1376	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1377		"bootfs=\"$zroot_name/$zroot_bootfs\"" "$zroot_name" ||
1378		return $FAILURE
1379
1380	# MBR boot loader touch-up
1381	if [ "$ZFSBOOT_PARTITION_SCHEME" = "MBR" ]; then
1382		# Export the pool(s)
1383		f_dprintf "$funcname: Temporarily exporting ZFS pool(s)..."
1384		f_eval_catch $funcname zpool "$ZPOOL_EXPORT" "$zroot_name" ||
1385			     return $FAILURE
1386		if [ "$ZFSBOOT_BOOT_POOL" ]; then
1387			f_eval_catch $funcname zpool "$ZPOOL_EXPORT" \
1388				     "$bootpool_name" || return $FAILURE
1389		fi
1390
1391		f_dprintf "$funcname: Updating MBR boot loader on disks..."
1392		# Stick the ZFS boot loader in the "convenient hole" after
1393		# the ZFS internal metadata
1394		for disk in $disks; do
1395			f_eval_catch $funcname dd "$DD_WITH_OPTIONS" \
1396			             /boot/zfsboot /dev/$disk$bootpart \
1397			             "skip=1 seek=1024" || return $FAILURE
1398		done
1399
1400		# Re-import the ZFS pool(s)
1401		f_dprintf "$funcname: Re-importing ZFS pool(s)..."
1402		f_eval_catch $funcname zpool "$ZPOOL_IMPORT_WITH_OPTIONS" \
1403			     "-o altroot=\"$BSDINSTALL_CHROOT\"" \
1404			     "$zroot_name" || return $FAILURE
1405		if [ "$ZFSBOOT_BOOT_POOL" ]; then
1406			# Import the bootpool, but do not mount it yet
1407			f_eval_catch $funcname zpool \
1408				     "$ZPOOL_IMPORT_WITH_OPTIONS" \
1409				     "-o altroot=\"$BSDINSTALL_CHROOT\" -N" \
1410				     "$bootpool_name" || return $FAILURE
1411		fi
1412	fi
1413
1414	# Remount bootpool and create symlink(s)
1415	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1416		f_eval_catch $funcname zfs "$ZFS_MOUNT" "$bootpool_name" ||
1417			return $FAILURE
1418		f_dprintf "$funcname: Creating /boot symlink for boot pool..."
1419		f_eval_catch $funcname ln "$LN_SF" "$bootpool_name/boot" \
1420		             $BSDINSTALL_CHROOT/boot || return $FAILURE
1421	fi
1422
1423	# zpool.cache is required to mount more than one pool at boot time
1424	f_dprintf "$funcname: Configuring zpool.cache for zroot..."
1425	f_eval_catch $funcname mkdir "$MKDIR_P" $BSDINSTALL_CHROOT/boot/zfs ||
1426	             return $FAILURE
1427	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1428	             "cachefile=\"$BSDINSTALL_CHROOT/boot/zfs/zpool.cache\"" \
1429	             "$zroot_name" || return $FAILURE
1430
1431	if [ "$ZFSBOOT_BOOT_POOL" ]; then
1432		f_eval_catch $funcname printf "$PRINTF_CONF" \
1433			vfs.root.mountfrom \
1434			"\"zfs:$zroot_name/$zroot_bootfs\"" \
1435			$BSDINSTALL_TMPBOOT/loader.conf.root || return $FAILURE
1436	fi
1437	#
1438	# Set canmount=noauto so that the default Boot Environment (BE) does
1439	# not get mounted if a different BE is selected from the beastie menu
1440	#
1441	f_dprintf "$funcname: Set canmount=noauto for the root of the pool..."
1442	f_eval_catch $funcname zfs "$ZFS_SET" "canmount=noauto" \
1443		"$zroot_name/$ZFSBOOT_BEROOT_NAME/$ZFSBOOT_BOOTFS_NAME"
1444
1445	# Last, but not least... required lines for rc.conf(5)/loader.conf(5)
1446	# NOTE: We later concatenate these into their destination
1447	f_dprintf "%s: Configuring rc.conf(5)/loader.conf(5) additions..." \
1448	          "$funcname"
1449	f_eval_catch $funcname echo "$ECHO_APPEND" 'zfs_enable=\"YES\"' \
1450	             $BSDINSTALL_TMPETC/rc.conf.zfs || return $FAILURE
1451	f_eval_catch $funcname echo "$ECHO_APPEND" \
1452	             'kern.geom.label.disk_ident.enable=\"0\"' \
1453	             $BSDINSTALL_TMPBOOT/loader.conf.zfs || return $FAILURE
1454	f_eval_catch $funcname echo "$ECHO_APPEND" \
1455	             'kern.geom.label.gptid.enable=\"0\"' \
1456	             $BSDINSTALL_TMPBOOT/loader.conf.zfs || return $FAILURE
1457
1458	if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
1459		f_eval_catch $funcname echo "$ECHO_APPEND" \
1460	             'vfs.zfs.min_auto_ashift=12' \
1461	             $BSDINSTALL_TMPETC/sysctl.conf.zfs || return $FAILURE
1462	fi
1463
1464	if [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1465		f_eval_catch $funcname echo "$ECHO_APPEND" \
1466		             'geom_mirror_load=\"YES\"' \
1467		             $BSDINSTALL_TMPBOOT/loader.conf.gmirror ||
1468		             return $FAILURE
1469	fi
1470
1471	# We're all done unless we should go on to do encryption
1472	[ "$ZFSBOOT_GELI_ENCRYPTION" ] || return $SUCCESS
1473
1474	#
1475	# Configure geli(8)-based encryption
1476	#
1477	f_dprintf "$funcname: Configuring disk encryption..."
1478	f_eval_catch $funcname echo "$ECHO_APPEND" 'aesni_load=\"YES\"' \
1479		$BSDINSTALL_TMPBOOT/loader.conf.aesni || return $FAILURE
1480	f_eval_catch $funcname echo "$ECHO_APPEND" 'geom_eli_load=\"YES\"' \
1481		$BSDINSTALL_TMPBOOT/loader.conf.geli || return $FAILURE
1482
1483	# We're all done unless we should go on for boot pool
1484	[ "$ZFSBOOT_BOOT_POOL" ] || return $SUCCESS
1485
1486	for disk in $disks; do
1487		f_eval_catch $funcname printf "$PRINTF_CONF" \
1488			geli_%s_keyfile0_load "$disk$targetpart YES" \
1489			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1490			return $FAILURE
1491		f_eval_catch $funcname printf "$PRINTF_CONF" \
1492			geli_%s_keyfile0_type \
1493			"$disk$targetpart $disk$targetpart:geli_keyfile0" \
1494			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1495			return $FAILURE
1496		f_eval_catch $funcname printf "$PRINTF_CONF" \
1497			geli_%s_keyfile0_name \
1498			"$disk$targetpart \"$ZFSBOOT_GELI_KEY_FILE\"" \
1499			$BSDINSTALL_TMPBOOT/loader.conf.$disk$targetpart ||
1500			return $FAILURE
1501	done
1502
1503	# Set cachefile for boot pool so it auto-imports at system start
1504	f_dprintf "$funcname: Configuring zpool.cache for boot pool..."
1505	f_eval_catch $funcname zpool "$ZPOOL_SET" \
1506	             "cachefile=\"$BSDINSTALL_CHROOT/boot/zfs/zpool.cache\"" \
1507	             "$bootpool_name" || return $FAILURE
1508
1509	# Some additional geli(8) requirements for loader.conf(5)
1510	for option in \
1511		'zpool_cache_load=\"YES\"' \
1512		'zpool_cache_type=\"/boot/zfs/zpool.cache\"' \
1513		'zpool_cache_name=\"/boot/zfs/zpool.cache\"' \
1514		'geom_eli_passphrase_prompt=\"YES\"' \
1515	; do
1516		f_eval_catch $funcname echo "$ECHO_APPEND" "$option" \
1517		             $BSDINSTALL_TMPBOOT/loader.conf.zfs ||
1518		             return $FAILURE
1519	done
1520	return $SUCCESS
1521}
1522
1523# dialog_menu_diskinfo
1524#
1525# Prompt the user to select a disk and then provide detailed info on it.
1526#
1527dialog_menu_diskinfo()
1528{
1529	local device disk
1530
1531	#
1532	# Break from loop when user cancels disk selection
1533	#
1534	while :; do
1535		device=$( msg_cancel="$msg_back" f_device_menu \
1536			"$DIALOG_TITLE" "$msg_select_a_disk_device" "" \
1537			$DEVICE_TYPE_DISK 2>&1 ) || break
1538		$device get name disk
1539
1540		# Show gpart(8) `show' and camcontrol(8) `inquiry' data
1541		f_show_msg "$msg_detailed_disk_info" \
1542			"$disk" "$( gpart show $disk 2> /dev/null )" \
1543			"$disk" "$( camcontrol inquiry $disk 2> /dev/null )" \
1544			"$disk" "$( camcontrol identify $disk 2> /dev/null )"
1545	done
1546
1547	return $SUCCESS
1548}
1549
1550############################################################ MAIN
1551
1552#
1553# Initialize
1554#
1555f_dialog_title "$msg_zfs_configuration"
1556f_dialog_backtitle "$msg_freebsd_installer"
1557
1558# User may have specifically requested ZFS-related operations be interactive
1559! f_interactive && f_zfsinteractive && unset $VAR_NONINTERACTIVE
1560
1561#
1562# Debugging
1563#
1564f_dprintf "BSDINSTALL_CHROOT=[%s]" "$BSDINSTALL_CHROOT"
1565f_dprintf "BSDINSTALL_TMPETC=[%s]" "$BSDINSTALL_TMPETC"
1566f_dprintf "FSTAB_FMT=[%s]" "$FSTAB_FMT"
1567
1568#
1569# Determine default boot type
1570#
1571case $(uname -m) in
1572arm64|riscv)
1573	# We support only UEFI boot for arm64 and riscv.
1574	: ${ZFSBOOT_BOOT_TYPE:=UEFI}
1575	: ${ZFSBOOT_PARTITION_SCHEME:=GPT}
1576	;;
1577*)
1578	# If the system was booted with UEFI, set the default boot type to UEFI
1579	bootmethod=$( sysctl -n machdep.bootmethod )
1580	f_dprintf "machdep.bootmethod=[%s]" "$bootmethod"
1581	if [ "$bootmethod" = "UEFI" ]; then
1582		: ${ZFSBOOT_BOOT_TYPE:=BIOS+UEFI}
1583		: ${ZFSBOOT_PARTITION_SCHEME:=GPT}
1584	else
1585		: ${ZFSBOOT_BOOT_TYPE:=BIOS}
1586		: ${ZFSBOOT_PARTITION_SCHEME:=GPT}
1587	fi
1588	;;
1589esac
1590
1591#
1592# Loop over the main menu until we've accomplished what we came here to do
1593#
1594while :; do
1595	if ! f_interactive; then
1596		retval=$DIALOG_OK
1597		mtag=">>> $msg_install"
1598	else
1599		dialog_menu_main
1600		retval=$?
1601		f_dialog_menutag_fetch mtag
1602	fi
1603
1604	f_dprintf "retval=%u mtag=[%s]" $retval "$mtag"
1605	[ $retval -eq $DIALOG_OK ] || f_die
1606
1607	case "$mtag" in
1608	">>> $msg_install")
1609		#
1610		# First, validate the user's selections
1611		#
1612
1613		# Make sure they gave us a name for the pool
1614		if [ ! "$ZFSBOOT_POOL_NAME" ]; then
1615			f_dprintf "Pool name cannot be empty."
1616			f_show_err "$msg_pool_name_cannot_be_empty"
1617			continue
1618		fi
1619
1620		# Validate vdev type against number of disks selected/scripted
1621		# (also validates that ZFSBOOT_DISKS are real [probed] disks)
1622		# NB: dialog_menu_layout supports running non-interactively
1623		dialog_menu_layout || continue
1624
1625		# Make sure each disk will have room for ZFS
1626		if f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize &&
1627		   f_expand_number "$ZFSBOOT_BOOT_POOL_SIZE" bootsize &&
1628		   f_expand_number "1g" zpoolmin
1629		then
1630			minsize=$(( $swapsize + $zpoolmin )) teeny_disks=
1631			[ "$ZFSBOOT_BOOT_POOL" ] &&
1632				minsize=$(( $minsize + $bootsize ))
1633			for disk in $ZFSBOOT_DISKS; do
1634				debug= f_device_find -1 \
1635					$disk $DEVICE_TYPE_DISK device
1636				$device get capacity disksize || continue
1637				[ ${disksize:-0} -ge 0 ] || disksize=0
1638				[ $disksize -lt $minsize ] &&
1639					teeny_disks="$teeny_disks $disk"
1640			done
1641			if [ "$teeny_disks" ]; then
1642				f_dprintf "swapsize=[%s] bootsize[%s] %s" \
1643				          "$ZFSBOOT_SWAP_SIZE" \
1644				          "$ZFSBOOT_BOOT_POOL_SIZE" \
1645				          "minsize=[$minsize]"
1646				f_dprintf "These disks are too small: %s" \
1647				          "$teeny_disks"
1648				f_show_err "$msg_these_disks_are_too_small" \
1649				           "$ZFSBOOT_SWAP_SIZE" \
1650				           "$ZFSBOOT_BOOT_POOL_SIZE" \
1651				           "$teeny_disks"
1652				continue
1653			fi
1654		fi
1655
1656		#
1657		# Last Chance!
1658		#
1659		if f_interactive; then
1660			dialog_last_chance $ZFSBOOT_DISKS || continue
1661		fi
1662
1663		#
1664		# Let's do this
1665		#
1666
1667		vdev_type="$ZFSBOOT_VDEV_TYPE"
1668
1669		# Blank the vdev type for the default layout
1670		[ "$vdev_type" = "stripe" ] && vdev_type=
1671
1672		zfs_create_boot "$ZFSBOOT_POOL_NAME" \
1673		                "$vdev_type" $ZFSBOOT_DISKS || continue
1674
1675		# To be reused by bootconfig
1676		echo "$ZFSBOOT_DISKS" > ${TMPDIR:-"/tmp"}/bsdinstall-zfsboot
1677
1678		break # to success
1679		;;
1680	?" $msg_pool_type_disks")
1681		ZFSBOOT_CONFIRM_LAYOUT=1
1682		dialog_menu_layout
1683		# User has poked settings, disable later confirmation
1684		ZFSBOOT_CONFIRM_LAYOUT=
1685		;;
1686	"- $msg_rescan_devices") f_device_rescan ;;
1687	"- $msg_disk_info") dialog_menu_diskinfo ;;
1688	?" $msg_pool_name")
1689		# Prompt the user to input/change the name for the new pool
1690		f_dialog_input input \
1691			"$msg_please_enter_a_name_for_your_zpool" \
1692			"$ZFSBOOT_POOL_NAME" &&
1693			ZFSBOOT_POOL_NAME="$input"
1694		;;
1695	?" $msg_force_4k_sectors")
1696		# Toggle the variable referenced both by the menu and later
1697		if [ "$ZFSBOOT_FORCE_4K_SECTORS" ]; then
1698			ZFSBOOT_FORCE_4K_SECTORS=
1699		else
1700			ZFSBOOT_FORCE_4K_SECTORS=1
1701		fi
1702		;;
1703	?" $msg_encrypt_disks")
1704		# Toggle the variable referenced both by the menu and later
1705		if [ "$ZFSBOOT_GELI_ENCRYPTION" ]; then
1706			ZFSBOOT_GELI_ENCRYPTION=
1707		else
1708			ZFSBOOT_FORCE_4K_SECTORS=1
1709			ZFSBOOT_GELI_ENCRYPTION=1
1710		fi
1711		;;
1712	?" $msg_partition_scheme")
1713		# Toggle between GPT (BIOS), GPT (UEFI) and MBR
1714		if [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT" -a \
1715		     "$ZFSBOOT_BOOT_TYPE" = "BIOS" ]
1716		then
1717			ZFSBOOT_PARTITION_SCHEME="GPT"
1718			ZFSBOOT_BOOT_TYPE="UEFI"
1719		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT" -a \
1720		       "$ZFSBOOT_BOOT_TYPE" = "UEFI" ]
1721		then
1722			ZFSBOOT_PARTITION_SCHEME="GPT"
1723			ZFSBOOT_BOOT_TYPE="BIOS+UEFI"
1724		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT" ]; then
1725			ZFSBOOT_PARTITION_SCHEME="MBR"
1726			ZFSBOOT_BOOT_TYPE="BIOS"
1727		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "MBR" ]; then
1728			ZFSBOOT_PARTITION_SCHEME="GPT + Active"
1729			ZFSBOOT_BOOT_TYPE="BIOS"
1730		elif [ "$ZFSBOOT_PARTITION_SCHEME" = "GPT + Active" ]; then
1731			ZFSBOOT_PARTITION_SCHEME="GPT + Lenovo Fix"
1732			ZFSBOOT_BOOT_TYPE="BIOS"
1733		else
1734			ZFSBOOT_PARTITION_SCHEME="GPT"
1735			ZFSBOOT_BOOT_TYPE="BIOS"
1736		fi
1737		;;
1738	?" $msg_swap_size")
1739		# Prompt the user to input/change the swap size for each disk
1740		while :; do
1741		    f_dialog_input input \
1742			    "$msg_please_enter_amount_of_swap_space" \
1743			    "$ZFSBOOT_SWAP_SIZE" &&
1744			    ZFSBOOT_SWAP_SIZE="${input:-0}"
1745		    if f_expand_number "$ZFSBOOT_SWAP_SIZE" swapsize
1746		    then
1747			if [ $swapsize -ne 0 -a $swapsize -lt 104857600 ]; then
1748			    f_show_err "$msg_swap_toosmall" \
1749				       "$ZFSBOOT_SWAP_SIZE"
1750			    continue;
1751			else
1752			    break;
1753			fi
1754		    else
1755			f_show_err "$msg_swap_invalid" \
1756				   "$ZFSBOOT_SWAP_SIZE"
1757			continue;
1758		    fi
1759		done
1760		;;
1761	?" $msg_swap_mirror")
1762		# Toggle the variable referenced both by the menu and later
1763		if [ "$ZFSBOOT_SWAP_MIRROR" ]; then
1764			ZFSBOOT_SWAP_MIRROR=
1765		else
1766			ZFSBOOT_SWAP_MIRROR=1
1767		fi
1768		;;
1769	?" $msg_swap_encrypt")
1770		# Toggle the variable referenced both by the menu and later
1771		if [ "$ZFSBOOT_SWAP_ENCRYPTION" ]; then
1772			ZFSBOOT_SWAP_ENCRYPTION=
1773		else
1774			ZFSBOOT_SWAP_ENCRYPTION=1
1775		fi
1776		;;
1777	esac
1778done
1779
1780exit $SUCCESS
1781
1782################################################################################
1783# END
1784################################################################################
1785